-- by mor2000

UniversalProcessKitBuilder = {}
UniversalProcessKitBuilderListener = {}

local function emptyFunc() end

UniversalProcessKitBuilder.cornerPoints = {}


----------------------------------------
-- UniversalProcessKitBuilderListener --
----------------------------------------

local ovArr = {}
local ovArrKey = 1
local printOverlays = false
local ovWhite = nil
local ovBlack = nil

function UniversalProcessKitBuilderListener.loadMap(name)
	local overlayHeight = 0.3
	local overlayWidth = overlayHeight / g_screenAspectRatio
	
	ovWhite = Overlay:new("white", upkModDirectory.."00_ressources/white.dds", 0.5-overlayWidth/2-0.1, 0.5-overlayHeight/2-0.1, overlayWidth+0.2, overlayHeight+0.2)
	ovBlack = Overlay:new("black", upkModDirectory.."00_ressources/black.dds", 0.5-overlayWidth/2, 0.5-overlayHeight/2, overlayWidth, overlayHeight)
	table.insert(ovArr,Overlay:new("001", "dataS2/menu/hud/fillTypes/hud_fill_wheat.png", 0.5-overlayWidth/2, 0.5-overlayHeight/2, overlayWidth, overlayHeight))
	--self.overlay002 = Overlay:new("002", modDirectory.."overlays/hand_green.dds", 0.5-self.overlayWidth/2, 0.5-overlayHeight/2, self.overlayWidth, overlayHeight)
end

function UniversalProcessKitBuilderListener.deleteMap(name)
	if ovWhite~=nil then
		ovWhite:delete()
	end
	if ovBlack~=nil then
		ovBlack:delete()
	end
	for _,ov in pairs(ovArr) do
		ov:delete()
	end
end

function UniversalProcessKitBuilderListener:update(dt)
end

function UniversalProcessKitBuilderListener.keyEvent(self,unicode,sym,modifier,isDown)
end

function UniversalProcessKitBuilderListener:hourChanged()
end

UniversalProcessKitBuilderListener.mouseEvent = emptyFunc

function  UniversalProcessKitBuilderListener:draw()
	if printOverlays then
		if ovWhite~=nil then
			ovWhite:render()
		end
		if ovBlack~=nil then
			ovBlack:render()
		end
		for k,ov in pairs(ovArr) do
			if k==ovArrKey then
				ov:render()
			end
		end
	end
	
	if not isPlayerActive() then
		return
	end
	local playerX, playerY, playerZ = getWorldTranslation(g_currentMission.player.rootNode)
	local locationPlayer = playerX*playerX + playerZ*playerZ
	for _,point in pairs(UniversalProcessKitBuilder.cornerPoints) do
		if point~=false then
			if mathabs(point.x*point.x + point.y*point.y - locationPlayer)<10000 then
			end
		end
	end
end

addModEventListener(UniversalProcessKitBuilderListener);

----

function printAny(...)
	local str=""
	for _,v in ipairs({...}) do
		str=str..tostring(v)
	end
	_g.print(str)
end;

function isPlayerActive()
	return g_currentMission.controlPlayer and
			g_currentMission.player~=nil
end

--------------------------------
-- UniversalProcessKitBuilder --
--------------------------------

function UniversalProcessKitBuilder:setCornerPoint()
	_m.printFn('UniversalProcessKitBuilder:setCornerPoint()');
	if not isPlayerActive() then
		_m.printErr('can set a corner point only as walker')
		return
	end
	
	local playerX, playerY, playerZ = getWorldTranslation(g_currentMission.player.rootNode)
	local terrainY = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, playerX, playerY, playerZ)
	
	local pos = __c({x=round(playerX,4), y=round(terrainY+1,4), z=round(playerZ,4)})
	
	local _, maxk = getMinMaxKeys(UniversalProcessKitBuilder.cornerPoints)
	local newk = (maxk or 0)+1
	table.insert(UniversalProcessKitBuilder.cornerPoints, newk, pos)
	printAny('new corner point ',newk,' set with x=',pos.x,' y=',pos.y,' and z=',pos.z)
end

function UniversalProcessKitBuilder:deleteCornerPoint(indexStr)
	_m.printFn('UniversalProcessKitBuilder:deleteCornerPoint(',indexStr,')')
	local index = tonumber(indexStr)
	if type(index)~="number" then
		_m.printErr('index has to be a number')
		return
	end
	if UniversalProcessKitBuilder.cornerPoints[index]==nil or UniversalProcessKitBuilder.cornerPoints[index]==false then
		_m.printErr('no corner point ',index,' set')
		return
	end
	UniversalProcessKitBuilder.cornerPoints[index] = false
	printAny('corner point ',index,' deleted')
end

function UniversalProcessKitBuilder:moveCornerPointX(indexStr,distance)
	_m.printFn('UniversalProcessKitBuilder:moveCornerPointX(',indexStr,', ',distance,')')
	local index = tonumber(indexStr)
	if type(index)~="number" then
		_m.printErr('index has to be a number')
		return
	end
	if UniversalProcessKitBuilder.cornerPoints[index]==nil or UniversalProcessKitBuilder.cornerPoints[index]==false then
		_m.printErr('no corner point ',index,' set')
		return
	end
	if type(distance)~="number" then
		_m.printErr('distance has to be a number')
		return
	end
	UniversalProcessKitBuilder.cornerPoints[index].x = UniversalProcessKitBuilder.cornerPoints[index].x + distance
end

function UniversalProcessKitBuilder:moveCornerPointY(indexStr,distance)
	_m.printFn('UniversalProcessKitBuilder:moveCornerPointY(',indexStr,', ',distance,')')
	local index = tonumber(indexStr)
	if type(index)~="number" then
		_m.printErr('index has to be a number')
		return
	end
	if UniversalProcessKitBuilder.cornerPoints[index]==nil or UniversalProcessKitBuilder.cornerPoints[index]==false then
		_m.printErr('no corner point ',index,' set')
		return
	end
	if type(distance)~="number" then
		_m.printErr('distance has to be a number')
		return
	end
	UniversalProcessKitBuilder.cornerPoints[index].y = UniversalProcessKitBuilder.cornerPoints[index].y + distance
end

function UniversalProcessKitBuilder:moveCornerPointZ(indexStr,distance)
	_m.printFn('UniversalProcessKitBuilder:moveCornerPointZ(',indexStr,', ',distance,')')
	local index = tonumber(indexStr)
	if type(index)~="number" then
		_m.printErr('index has to be a number')
		return
	end
	if UniversalProcessKitBuilder.cornerPoints[index]==nil or UniversalProcessKitBuilder.cornerPoints[index]==false then
		_m.printErr('no corner point ',index,' set')
		return
	end
	if type(distance)~="number" then
		_m.printErr('distance has to be a number')
		return
	end
	UniversalProcessKitBuilder.cornerPoints[index].z = UniversalProcessKitBuilder.cornerPoints[index].z + distance
end

function UniversalProcessKitBuilder:printCornerPoints(...)
	_m.printFn('UniversalProcessKitBuilder:printCornerPoints()')
	local arr = {...}
	local arrNrs = {}
	local dontCheckIndex = length(arr)==0
	if not dontCheckIndex then
		for _,v in pairs(arr) do
			table.insert(arrNrs,tonumber(v))
		end
	end
	for k,point in pairs(UniversalProcessKitBuilder.cornerPoints) do
		if point~=false and (dontCheckIndex or isInTable(arrNrs,k)) then
			printAny('corner point ',k,' set with x=',point.x,' y=',point.y,' and z=',point.z)
		end
	end
	
end

function UniversalProcessKitBuilder:printCornerPoint(indexStr)
	_m.printFn('UniversalProcessKitBuilder:printCornerPoint(',indexStr,')')
	local index = tonumber(indexStr)
	if type(index)~="number" then
		_m.printErr('index has to be a number')
		return
	end
	if UniversalProcessKitBuilder.cornerPoints[index]==nil or UniversalProcessKitBuilder.cornerPoints[index]==false then
		_m.printErr('no corner point ',index,' set')
		return
	end
	local point = UniversalProcessKitBuilder.cornerPoints[index]
	printAny('corner point ',index,' set with x=',point.x,' y=',point.y,' and z=',point.z)
end

function UniversalProcessKitBuilder:exec()
	--printOverlays = not printOverlays
	--saveScreenshot("lala.png")
	printAny("-- InputBinding.actions[InputBinding.TAKE_SCREENSHOT] --")
	for key,value in pairs(_g.InputBinding.actions[InputBinding.TAKE_SCREENSHOT]) do
		printAny(key,": ",value)
		--for key2,value2 in pairs(value) do
		--	printAny(key,".",key2," = ",value2)
		--end
	end
	--printAny(FSCareerMissionInfo.getSavegameDirectory())
	printAny("==============")
end

addConsoleCommand("upkSetCornerPoint", "set a corner point", "setCornerPoint", UniversalProcessKitBuilder);
addConsoleCommand("upkDeleteCornerPoint", "delete a corner point", "deleteCornerPoint", UniversalProcessKitBuilder);
addConsoleCommand("upkMoveCornerPointX", "move a corner point along the x-axis", "moveCornerPointX", UniversalProcessKitBuilder);
addConsoleCommand("upkMoveCornerPointY", "move a corner point along the y-axis", "moveCornerPointY", UniversalProcessKitBuilder);
addConsoleCommand("upkMoveCornerPointZ", "move a corner point along the z-axis", "moveCornerPointZ", UniversalProcessKitBuilder);
addConsoleCommand("upkPrintCornerPoint", "print coordinates of a corner point", "printCornerPoint", UniversalProcessKitBuilder);
addConsoleCommand("upkPrintCornerPoints", "print coordinates of corner points", "printCornerPoints", UniversalProcessKitBuilder);

addConsoleCommand("upkExec", "manual execute a script", "exec", UniversalProcessKitBuilder);